package com.trs.ggzyexchange.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.api.vo.Result;
import com.trs.ggzyexchange.entity.*;
import com.trs.ggzyexchange.enums.BulletinType;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.service.*;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 中标候选人公示 前端控制器
 * </p>
 *
 * @author trs
 * @since 2023-02-16
 */
@RestController
@RequestMapping("/gc-bidcandidate-post")
public class GcBidcandidatePostController extends BaseController {

    @Autowired
    private GcBidcandidatePostService gcBidcandidatePostService;

    @Autowired
    private AreaDataName areaDataName;

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private TenderDetailsVoService tenderDetailsVoService;

    //@GetMapping(value = "/list")
    public Result<IPage<GcBidcandidatePostVo>> queryPageList(GcBidcandidatePost gcBidcandidatePost,
                                                          @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
                                                          @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
                                                          HttpServletRequest req) {
        Page<GcBidcandidatePost> page = new Page<GcBidcandidatePost>(pageNo, pageSize);
        IPage<GcBidcandidatePostVo> pageList = gcBidcandidatePostService.queryGcBidcandidatePostList(page, gcBidcandidatePost);
        List<GcBidcandidatePostVo> records = pageList.getRecords();
        for (GcBidcandidatePostVo record : records) {
            String regionCode = record.getRegionCode();
            String platformCode = record.getPlatformCode();
            String areaDataName = this.areaDataName.getAreaDataName(regionCode, platformCode);
            record.setArea(areaDataName);
        }
        pageList.setRecords(records);
        return Result.OK(pageList);
    }

    //@GetMapping(value = "/queryPageListAll")
    public Result<IPage<TenderDetailsVo>> queryPageListAll(
            @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
            @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
            HttpServletRequest req
    ){
        Page<GcBidcandidatePost> page = new Page<GcBidcandidatePost>(pageNo, pageSize);
        IPage<TenderDetailsVo> tenderDetailsVoIPage = gcBidcandidatePostService.queryGcBidcandidatePostAllList(page);
        for (TenderDetailsVo record : tenderDetailsVoIPage.getRecords()) {
            record.setNoticeTypeCode(ClassIfy.PUBLICITY_OF_BID_WINNER_CANDIDATES.getCode());
            record.setNoticeTypeName(ClassIfy.PUBLICITY_OF_BID_WINNER_CANDIDATES.getName());
            record.setTransactionTypeCode(ClassIfy.ENGINEERING_CONSTRUCTION.getCode());
            record.setTransactionTypeName(ClassIfy.ENGINEERING_CONSTRUCTION.getName());
            record = tenderDetailsVoService.getTenderDetailsVoAllOrther(record);
            TenderDetailsVoUtils.isNull(record);
        }
        return Result.OK(tenderDetailsVoIPage);
    }

    //@GetMapping(value = "/queryPageListUpdateEs")
    public Integer queryPageListUpdateEs() throws JsonProcessingException {
        int count = gcBidcandidatePostService.count();
        Integer pageNo = 1;
        Integer pageSize = 1000;
        Integer pageNum = (int)Math.ceil((double)count/pageSize);
        List<TenderDetailsVo> tenderDetailsVos = new ArrayList<TenderDetailsVo>();
        for(int i = 1; i <= pageNum;i++){
            List<TenderDetailsVo> tenderDetailsVoListAll = getTenderDetailsVoListAll(i, pageSize);
            Boolean aBoolean = gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVoListAll);
        }
        return tenderDetailsVos.size();
    }
    public List<TenderDetailsVo> getTenderDetailsVoListAll(Integer pageNo,Integer pageSize){
        Page<GcBidcandidatePost> page = new Page<GcBidcandidatePost>(pageNo, pageSize);
        IPage<TenderDetailsVo> tenderDetailsVoIPage = gcBidcandidatePostService.queryGcBidcandidatePostAllList(page);
        for (TenderDetailsVo record : tenderDetailsVoIPage.getRecords()) {
            record.setNoticeTypeCode(ClassIfy.PUBLICITY_OF_BID_WINNER_CANDIDATES.getCode());
            record.setNoticeTypeName(ClassIfy.PUBLICITY_OF_BID_WINNER_CANDIDATES.getName());
            record.setTransactionTypeCode(ClassIfy.ENGINEERING_CONSTRUCTION.getCode());
            record.setTransactionTypeName(ClassIfy.ENGINEERING_CONSTRUCTION.getName());
            record = tenderDetailsVoService.getTenderDetailsVoAllOrther(record);
            TenderDetailsVoUtils.isNull(record);
        }
        return tenderDetailsVoIPage.getRecords();
    }
}
